/***************************************************************************
                          solve.h  -  description
                             -------------------
    begin                : Fri Mar 28 2003
    copyright            : (C) 2003 by Dominik Raddatz
    email                : dom@wtal.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SOLVE_H
#define SOLVE_H

#include "constants.h"

int solve();
void insert(bool box[3][4][5], int pieceIndex);
void insert(const long long &indexMask, const long long &andMask, const long long &equalsMask);

void initializePC();
void convert(bool source[3][4][5], long long *target);
int findLowestBit(long long piece);
inline bool testBit(const long long *piece, const int position);
void permute(const long long *source, long long *target);

void *solve12(void *nothing);
void solve11(const long long box, int fillPosition, int remainingPiecesList[13]);
void solve10(const long long box, int fillPosition, int remainingPiecesList[13]);
void solve9(const long long box, int fillPosition, int remainingPiecesList[13]);
void solve8(const long long box, int fillPosition, int remainingPiecesList[13]);
void solve7(const long long box, int fillPosition, int remainingPiecesList[13]);
inline void solve6(const long long box, int fillPosition, int remainingPiecesList[13]);
inline void solve5(const long long box, int fillPosition, int remainingPiecesList[13]);
inline void solve4(const long long box, int fillPosition, int remainingPiecesList[13]);
inline void solve3(const long long box, int fillPosition, int remainingPiecesList[13]);
inline void solve2(const long long box, int fillPosition, int remainingPiecesList[13]);
inline void solve1(const long long box, int fillPosition, int remainingPiecesList[13]);


#endif
